<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Shoutbox for NETTUTS by Dan Harper</title>
<link rel="stylesheet" href="style.css" type="text/css" />
</head>
<body>
<div id="container">

  <h1>Shoutbox</h1>
  <h5><a href="http://www.danharper.me" title="Dan Harper">Dan Harper</a> : <a href="http://www.nettuts.com" title="NETTUTS - Spoonfed Coding Skills">NETTUTS</a></h5>

  <div id="boxtop"></div>
  <div id="content">
    
	<?php
    $self = $_SERVER['PHP_SELF']; //the $self variable equals this file
    $ipaddress = ("$_SERVER[REMOTE_ADDR]"); //the $ipaddress var equals users IP
    include ('db.php'); // for db details
    
    // defines a $connect variable, which when used
    // will attempt to connect to the databse using
    // details provided in config.php
    // if it fails, will display error - or die();
    $connect = mysql_connect($host,$username,$password) or die('<p class="error">Unable to connect to the database server at this time.</p>');
    
    // connect to database using details provided
    // and uses the $connect variable above
    // if it fails, will return error - or die();
    mysql_select_db($database,$connect) or die('<p class="error">Unable to connect to the database at this time.</p>');
    
    
        // checks the POST to see if something has been submitted
        if(isset($_POST['send'])) {
            // are any of the fields empty? the || means 'or'
            if(empty($_POST['name']) || empty($_POST['email']) || empty($_POST['post'])) {
                echo('<p class="error">You did not fill in a required field.</p>');
            } else {
            
                // if there are no empty fields, insert into the database:
        
                // escape special characters to stop xss and sql injecting
                // we take the 'name' and 'post' parts from the POST
                // and run it through htmlspecialchars()
                // this stops users sending HTML code, as it could be malicious
                //
                // also runs through mysql_real_escape_string()
                // stops users sending SQL code, which could be used to access the db
                $name = htmlspecialchars(mysql_real_escape_string($_POST['name'])); 
                $email = htmlspecialchars(mysql_real_escape_string($_POST['email'])); 
                $post = htmlspecialchars(mysql_real_escape_string($_POST['post']));
            
                    // this is our SQL string to insert shouts into db
                    $sql = "INSERT INTO shouts SET name='$name', email='$email', post='$post', ipaddress='$ipaddress';";
            
                        // we run the SQL string now
                        // if it succeeds, display message
                        if (@mysql_query($sql)) {
                            echo('<p class="success">Thanks for shouting!</p>');
                        } else {
                            // if it errors, send message
                            echo('<p class="error">There was an unexpected error when posting your shout.</p>');
                        }
            }
        }
    
        // now we retrieve the 8 latest shouts from the db
        $query = "SELECT * FROM shouts ORDER BY `id` DESC LIMIT 8;";
    
        // run the query. if it fails, display error
        $result = @mysql_query("$query") or die('<p class="error">There was an unexpected error grabbing shouts from the database.</p>');
        
        ?><ul><?
        // while we still have rows from the db, display them
        while ($row = mysql_fetch_array($result)) {
        
            $ename = stripslashes($row['name']);
            $eemail = stripslashes($row['email']);
            $epost = stripslashes($row['post']);
            
            // Woop! We can use Gravatars aswell!!
            $grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5(strtolower($eemail))."&size=70"; 
            
            echo('<li><div class="meta"><img src="'.$grav_url.'" alt="Gravatar" /><p>'.$ename.'</p></div><div class="shout"><p>'.$epost.'</p></div></li>');
        
        }
        ?></ul><?
        
    ?>
    
    <!-- at the bottom of the page, we display our comment form -->
    <form action="<?php $self ?>" method="post">
    <h2>Shout!</h2>
    <div class="fname"><label for="name"><p>Name:</p></label><input name="name" type="text" cols="20" /></div>
    <div class="femail"><label for="email"><p>Email:</p></label><input name="email" type="text" cols="20" /></div>
    <textarea name="post" rows="5" cols="40"></textarea>
    <input name="send" type="hidden" />
    <p><input type="submit" value="send" /></p>
    </form>
    
   
  </div><!--/content-->
  <div id="boxbot"></div>

</div><!--/container-->

</body>
</html>
